## q4wine 1.3.13

=== CMakeLists.txt ===
project(Q4Wine)

cmake_minimum_required(VERSION 2.8.0)

add_subdirectory(src)
