=== debian/changelog ===
q4wine (1.3.13-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:19:11 +1100

q4wine (1.3.13-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:35:50 +0000

q4wine (1.3.13-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2 (was 4.5.1): no changes required
  * Update debian/watch.
  * Update years in debian/copyright.
  * Update debian/lintian-overrides.
  * Add debian/source/lintian-overrides.

 -- Boris Pek <tehnick@debian.org>  Fri, 10 Feb 2023 03:22:37 +0300
