=== debian/watch ===
version=4
http://sf.net/@PACKAGE@/@PACKAGE@-(.+)@ARCHIVE_EXT@ \
debian uupdate
